'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

exports.start = start;
exports.stop = stop;
exports.request = request;
exports.addEntry = addEntry;

var _actions = require('./actions');

var _reducer = require('./reducer');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function start(_ref, action, next) {
    var getState = _ref.getState,
        dispatch = _ref.dispatch;

    var state = getState();
    var pollingName = action.meta.pollingName;

    var _getPollingState = (0, _reducer.getPollingState)(state, pollingName),
        isActive = _getPollingState.isActive;

    if (isActive) {
        return false;
    }

    next(action);

    var requestAction = (0, _actions.createAction)(_actions.actionTypes.request, action.meta);
    dispatch(requestAction);

    return true;
}

function stop(_, action, next) {
    next(action);
    return true;
}

function request(_ref2, action) {
    var getState = _ref2.getState,
        dispatch = _ref2.dispatch;

    var state = getState();
    var pollingName = action.meta.pollingName;

    var _getPollingState2 = (0, _reducer.getPollingState)(state, pollingName),
        isActive = _getPollingState2.isActive,
        requestPayload = _getPollingState2.requestPayload;

    if (!isActive) {
        return false;
    }

    var _action$meta = action.meta,
        callbacks = _action$meta.callbacks,
        pollingInterval = _action$meta.pollingInterval;

    return Promise.resolve(callbacks.polling.apply(callbacks, (0, _toConsumableArray3.default)(requestPayload).concat([getState]))).then(function (value) {
        var addEntryAction = (0, _actions.createAction)(_actions.actionTypes.addEntry, action.meta, value);
        dispatch(addEntryAction);
    }, function (err) {
        return err;
    } // If exception during polling - do nothing
    ).then(function () {
        setTimeout(function () {
            var requestAction = (0, _actions.createAction)(_actions.actionTypes.request, action.meta);
            dispatch(requestAction);
        }, pollingInterval);
    });
}

function addEntry(_ref3, action, next) {
    var getState = _ref3.getState;
    var callbacks = action.meta.callbacks;

    var value = action.payload;

    var shouldAddEntry = true;
    if (typeof callbacks.shouldAddEntry === 'function') {
        shouldAddEntry = callbacks.shouldAddEntry(getState, value);
    }

    if (shouldAddEntry) {
        next(action);
    }

    return shouldAddEntry;
}